import pyglet
from pyglet import resource

resource.path.append('game/resources')
resource.reindex()
# --------------------------------------------------------------------------
# Load resources
# --------------------------------------------------------------------------

def centre_anchor(img):
  img.anchor_x = img.width // 2
  img.anchor_y = img.height // 2
  return img

# Scene resources
BACKGROUND_IMG = resource.image("background.png")
RAILWAY_IMG = resource.image("railway.png")

# Weapons
BULLET_IMAGES = resource.image('bullet.png')

DYNAMITE_IMG = resource.image("dynamite_01.png")
CANNON_IMG = resource.image("cannon.png")
CANNON_BALL_IMG = resource.image("cannon_ball_01.png")
ROCKET_IMG = resource.image("rocket.png")
HEALTH_IMG = resource.image("health_grid.png")
SHIELD_IMG = resource.image("shield_grid.png")

explosion_images = resource.image('explosion.png')
explosion_images = pyglet.image.ImageGrid(explosion_images, 2, 8)
EXPLOSION_IMGS = explosion_images.get_texture_sequence()

EXPLOSION_ANIMATION_PERIOD = 0.01

for explosion_image in EXPLOSION_IMGS:
  explosion_image.anchor_x = explosion_image.width // 2
  explosion_image.anchor_y = explosion_image.height // 2

EXPLOSION_ANIMATION = (pyglet.image.Animation.from_image_sequence(EXPLOSION_IMGS,
                                                                  EXPLOSION_ANIMATION_PERIOD,
                                                                  loop=False
                                                                  )
                       )
health_imgs = pyglet.image.ImageGrid(HEALTH_IMG, 1, 8)
HEALTH_IMGS = health_imgs.get_texture_sequence()
for health_img in HEALTH_IMGS:
  health_img.anchor_x = health_img.width // 2
  health_img.anchor_y = health_img.height // 2
HEALTH_ANIMATION = pyglet.image.Animation.from_image_sequence(
  HEALTH_IMGS, 0.1, loop=False
)

shield_imgs = pyglet.image.ImageGrid(SHIELD_IMG, 1, 8)
SHIELD_IMGS = shield_imgs.get_texture_sequence()
for shield_img in SHIELD_IMGS:
  shield_img.anchor_x = shield_img.width // 2
  shield_img.anchor_y = shield_img.height // 2
SHIELD_ANIMATION = pyglet.image.Animation.from_image_sequence(
  SHIELD_IMGS, 0.1, loop=False
)


# SFX

BULLET_SFX = resource.media('sound/bullet.wav', streaming=False)

EXPLOSION_SFX = resource.media('sound/explosion2_16bit.wav', streaming=False)

CANNON_SFX = resource.media('sound/cannon_fire.wav', streaming=False)

# Pointer
pointer_image = centre_anchor(resource.image('pointer.png'))
POINTER_IMG = pointer_image
POINTER_IMG_FLIP = resource.image('pointer.png', flip_x=True)

# Player
player_image = resource.image("player/cowboy_idle_0.png")
player_image.anchor_x = player_image.width // 4
player_image.anchor_y = player_image.height // 2
PLAYER_IMG = player_image

# Pirate Ship
pirate_ship_image = resource.image("pirate_ship_01.png")
pirate_ship_image.anchor_x = pirate_ship_image.width // 2
pirate_ship_image.anchor_y = pirate_ship_image.height // 2
PIRATE_SHIP_IMG = pirate_ship_image

# Train
WHEEL_IMG = resource.image("train_wheel_01.png")
ENGINE_IMG = resource.image("train_engine_01.png")
ENGINE_IMG.anchor_x = ENGINE_IMG.width // 2
ENGINE_IMG.anchor_y = ENGINE_IMG.height // 2
CARRIAGE_IMG = centre_anchor(resource.image("train_carriage_01.png"))
CARRIAGE_DYNAMITE_IMG = centre_anchor(resource.image("train_carriage_dynamite.png"))
CARRIAGE_ROCKET_IMG = centre_anchor(resource.image("train_carriage_rocket.png"))
CARRIAGE_LOOT_IMG = centre_anchor(resource.image("train_carriage_loot.png"))
CARRIAGE_HEALTH_IMG = centre_anchor(resource.image("train_carriage_health.png"))
CARRIAGE_SHIELD_IMG = centre_anchor(resource.image("train_carriage_shield.png"))

smoke_image = resource.image('smoke.png')
SMOKE_IMG = pyglet.image.ImageGrid(smoke_image, 1, 8)
# SMOKE_ANIMATION = \
#     pyglet.image.Animation.from_image_sequence(smoke_images,
#                                                SMOKE_ANIMATION_PERIOD,
#                                                loop=False)
