import pyglet


SCORE_FONT_SIZE = 24
SCORE_FONT_COLOUR = (46, 49, 49, 255)

class ScoreBoard:
    def __init__(self, batch, x, y, initial_score, initial_level):
        self._score = initial_score
        self._level = initial_level
        self.sprite = pyglet.text.Label(
            text=f"Score: {self.score}", 
            font_size=SCORE_FONT_SIZE,
            bold=True,
            color=SCORE_FONT_COLOUR,
            x=x, 
            y=y,
            anchor_x='left',
            anchor_y='top',
            batch=batch
        )
        self.level_sprite = pyglet.text.Label(
            text=f"Level: {self.level}",
            font_size=SCORE_FONT_SIZE,
            bold=True,
            color=SCORE_FONT_COLOUR,
            x=x, 
            y=y + SCORE_FONT_SIZE * 1.5,
            anchor_x='left',
            anchor_y='top',
            batch=batch
        )

    
    @property
    def score(self) -> int:
        return self._score

    @property
    def level(self) -> int:
        return self._level

    @level.setter
    def level(self, level):
        self._level = level
        self.level_sprite.text=f"Level: {self.level}"

    def modify_score(self, n: int):
        self._score += n
        self.sprite.text = f"Score: {self.score}"

    def resize(self, x: int, y: int):
        self.sprite.x = x
        self.sprite.y = y
        print(f"Sprite: {self.sprite.position}")
